"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Validator_1 = require("./validate-json/Validator");
var Validator_2 = require("./validate-json/Validator");
exports.Validator = Validator_2.Validator;
const jsonMemo = new WeakMap();
const queryMemo = new WeakMap();
const verboseDev = (arg) => typeof arg === 'boolean' ? arg : process.env.NODE_ENV !== 'prod';
function validateJson(shape, verbose) {
    if (!jsonMemo.has(shape)) {
        const validator = new Validator_1.Validator(shape, verboseDev(verbose));
        const handler = (req, res, next) => {
            if (!validator.validate(req.body)) {
                next(400);
            }
            else {
                next();
            }
        };
        jsonMemo.set(shape, handler);
    }
    return jsonMemo.get(shape);
}
exports.validateJson = validateJson;
function validateQuery(shape, verbose) {
    if (!queryMemo.has(shape)) {
        const validator = new Validator_1.Validator(shape, verboseDev(verbose));
        const handler = (req, res, next) => {
            if (!validator.validate(req.query)) {
                next(400);
            }
            else {
                next();
            }
        };
        queryMemo.set(shape, handler);
    }
    return queryMemo.get(shape);
}
exports.validateQuery = validateQuery;
