"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Log_1 = require("../utils/Log");
const Sql_1 = require("./Sql");
const User_1 = require("./User");
const isProd = process.env.NODE_ENV === 'prod';
function useContext(config) {
    Sql_1.Sql.createPool(config.sql);
    return (req, res, next) => {
        req.context = {
            data: {},
            log: new Log_1.Log(),
            sql: new Sql_1.Sql(),
            user: new User_1.User(isProd, config.user, req, res),
        };
        req.context.user.authenticate();
        next();
    };
}
exports.useContext = useContext;
