"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function useCors({ corsDomain }) {
    if (!corsDomain)
        return (req, res, next) => next();
    return (req, res, next) => {
        res.set({
            'Access-Control-Allow-Origin': corsDomain,
            'Access-Control-Allow-Header': '*',
            'Access-Control-Allow-Method': 'OPTIONS, GET, POST, PUT, PATCH, DELETE',
        });
        next();
    };
}
exports.useCors = useCors;
