"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Log {
    constructor(level = 0, prefix = '') {
        this.level = level;
        this.prefix = prefix;
    }
    info(...out) {
        console.info(this.printPrefix(), ...out);
    }
    debug(...out) {
        console.log(this.printPrefix(), ...out);
    }
    warn(...out) {
        console.warn(this.printPrefix(), ...out);
    }
    error(...out) {
        console.error(this.printPrefix(), ...out);
    }
    getSub(prefix = '') {
        return new Log(this.level + 1, prefix);
    }
    printPrefix() {
        return '  '.repeat(this.level) + `[${this.prefix}]`;
    }
}
exports.Log = Log;
