"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const SqlInstaller_1 = require("./upgrade/SqlInstaller");
async function upgrade(config, log) {
    log.info('Start');
    const { sql, versionsDir } = config;
    const success = await new SqlInstaller_1.SqlInstaller(sql, versionsDir, log.getSub('sql')).run();
    if (success) {
        log.info('Completed');
    }
    else {
        log.error('Failed');
    }
    return success;
}
exports.upgrade = upgrade;
