"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function applyMacros(sql) {
    return sql.replace(MACRO, (_, macro, args) => {
        const params = {};
        for (const pair of args.trim().split(' ')) {
            const [name, value] = pair.split(':');
            params[name] = value || true;
        }
        return Macros[macro].call(undefined, params);
    });
}
exports.applyMacros = applyMacros;
const MACRO = /\/\* !([A-Z]+) (.*)\*\//g;
const ID_TYPE = 'VARCHAR(24)';
const Macros = {
    ENV: ({ name }) => process.env[name],
    ID: () => `id ${ID_TYPE} PRIMARY KEY`,
    FKEY: ({ table, soft, pk, type = ID_TYPE, col = 'id' }) => [
        type,
        soft ? 'DEFAULT NULL' : 'NOT NULL',
        pk ? 'PRIMARY KEY' : '',
        'REFERENCES',
        `${table}(${col})`,
        soft ? 'ON DELETE SET NULL' : 'ON DELETE CASCADE',
    ].join(' '),
    USER: ({ soft, pk }) => Macros.FKEY({ table: 'paperhat.users', type: 'INT', soft, pk }),
};
