import { Application } from 'express';

import { SqlConfig } from '../middleware/Sql';
import { UserConfig } from '../middleware/User';
import { UpgradeConfig } from '../utils/upgrade';

export interface Config {
  server: ServerConfig;
  user: UserConfig;
  sql: SqlConfig;
  upgrade: UpgradeConfig;

  init?: (api: Application) => Promise<void>;
}

export interface ServerConfig {
  port: number;
  appsRoot: string;
  corsDomain?: string;
  jsonSizeLimit?: string | number;
}
