export interface SqlCursor<T> {
  next(count: number): Promise<T[]>;
  close(): void;
}

export interface SqlClient {
  one<T = any>(strings: TemplateStringsArray, ...merges: any[]): Promise<T>;
  q<T = any>(strings: TemplateStringsArray, ...merges: any[]): Promise<T[]>;
  cur<T = any>(
    strings: TemplateStringsArray,
    ...merges: any[]
  ): Promise<SqlCursor<T>>;

  raw<T = any>(text: string, values: any[]): Promise<T[]>;

  get<T = any>(table: string, value: any, matchBy?: string): Promise<T>;
  value<T = any>(sql: string, values: any[], name?: string): Promise<T>;
  insert<T = any>(
    table: string,
    row: Partial<T>,
    returning?: string,
  ): Promise<T>;
  update<T = any>(
    table: string,
    row: Partial<T>,
    matchBy?: string,
  ): Promise<boolean>;
  delete<T = any>(
    table: string,
    row: Partial<T>,
    matchBy?: string,
  ): Promise<boolean>;

  transaction<R = any>(
    block: (tx: SqlClient) => Promise<R | boolean>,
  ): Promise<R>;
  arrayTransaction<T = any, R = any>(
    items: T[],
    operation: (tx: SqlClient, item: T, i: number) => Promise<R>,
  ): Promise<R[]>;
}
