import { Handler } from 'express';
import { ServerConfig } from '../exports/Config';

export function useCors({ corsDomain }: ServerConfig): Handler {
  if (!corsDomain) return (req, res, next) => next();

  return (req, res, next) => {
    res.set({
      'Access-Control-Allow-Origin': corsDomain,
      'Access-Control-Allow-Header': '*',
      'Access-Control-Allow-Method': 'OPTIONS, GET, POST, PUT, PATCH, DELETE',
    });
    next();
  };
}
