import { Request, Response, NextFunction } from 'express';

export function handleErrors(
  err: any,
  req: Request,
  res: Response,
  next: NextFunction,
) {
  if (res.headersSent) {
    return next(err);
  }

  if (typeof err === 'number') {
    res.sendStatus(err);
  } else {
    req.context.log.error(err);
    res.sendStatus(500);
  }
}
