export class Log {
  constructor(private readonly level = 0, private readonly prefix = '') {}

  info(...out: any[]) {
    console.info(this.printPrefix(), ...out);
  }

  debug(...out: any[]) {
    console.log(this.printPrefix(), ...out);
  }

  warn(...out: any[]) {
    console.warn(this.printPrefix(), ...out);
  }

  error(...out: any[]) {
    console.error(this.printPrefix(), ...out);
  }

  getSub(prefix = '') {
    return new Log(this.level + 1, prefix);
  }

  private printPrefix() {
    return '  '.repeat(this.level) + `[${this.prefix}]`;
  }
}
