import { SqlInstaller, SqlInstallerConfig } from './upgrade/SqlInstaller';
import { Log } from './Log';

export interface UpgradeConfig {
  versionsDir: string;
  sql: SqlInstallerConfig;
}

export async function upgrade(
  config: UpgradeConfig,
  log: Log,
): Promise<boolean> {
  log.info('Start');

  const { sql, versionsDir } = config;
  const success = await new SqlInstaller(
    sql,
    versionsDir,
    log.getSub('sql'),
  ).run();

  if (success) {
    log.info('Completed');
  } else {
    log.error('Failed');
  }

  return success;
}
