export interface Shape {
    [key: string]: Primitive | Complex;
}
export declare type Primitive = 'string' | 'number' | 'boolean' | 'any' | 'forbidden';
export declare type ComplexBase = {
    optional?: boolean;
    check?: Validator;
};
export declare type Complex = ComplexBase & ({
    type: 'boolean';
} | ({
    type: 'string';
} & StringConstraints) | ({
    type: 'number';
} & NumberConstraints) | ({
    type: 'object';
} & ObjectConstraints) | ({
    type: 'array';
} & ArrayConstraints) | ({
    type: 'enum';
} & EnumConstraints));
export declare type Validator = (value: any, obj: any) => boolean;
export declare type StringConstraints = {
    minLength?: number;
    maxLength?: number;
    pattern?: RegExp;
};
export declare type NumberConstraints = {
    min?: number;
    max?: number;
    integer?: boolean;
};
export declare type ObjectConstraints = {
    shape: Shape;
};
export declare type ArrayConstraints = {
    of: Primitive | Complex;
    minLength?: number;
    maxLength?: number;
};
export declare type EnumConstraints = {
    of: string[];
};
