import { Request, Response } from 'express';
export interface UserConfig {
    cookieName: string;
    cookie: {
        path: string;
        domain: string;
        maxAge: number;
    };
    jwtSecret: string;
    hardAge: number;
    payloadFields: string[];
}
export declare class User {
    private readonly isProd;
    private readonly config;
    private readonly req;
    private readonly res;
    private state;
    private data;
    constructor(isProd: boolean, config: UserConfig, req: Request, res: Response);
    authenticate(): void;
    login(data: any, hard?: boolean): void;
    logout(): void;
    isGuest(): boolean;
    isHard(): boolean;
    get(): any;
    getRemoteIp(): string;
    private verify;
    private setCookie;
}
